// DllStub.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <conio.h> // getch()

#include "LoadProcWrappers.h"
#include "LoadProcWrappersRetVal.h"


LOADPROC_NO_RETURN_VALUE_1(kernel32_Sleep, "kernel32", "Sleep" , int);
LOADPROC_NO_RETURN_VALUE_2(MyBeep, "kernel32", "Beep", int, int);
LOADPROC_NO_RETURN_VALUE_2(MyBeep2, "kernel32", "Beep", int, int);
LOADPROC_WITH_RETURN_VALUE_1(TESTMISSING, "kernel32", "ThisOneDoesntExistFroSure", int, int);

int main(int argc, char* argv[])
{

   kernel32_Sleep slp;
   MyBeep         f2;
   MyBeep2        f3;
   TESTMISSING    foo;

   slp.SetPreferredPath("d:\\", CLsd(CLsd::E_SYSTEMDIR), ".");

   // On Windows 9x Beep doesn't work properly :(, better try on NT/2K/XP
   f2(440,200);
   f2(880,200);
   f2(440,200);
   f2(880,200);

   slp(500);

   f3(440,200);
   f3(880,200);
   f3(880,200);
   f3(440,200);

   // default is no exceptions on missing entries
   int   nTRV;

   nTRV = foo(777);
   printf("default return value is %d\n", nTRV);

   // now we'll be throwing (exceptions) - and catching too
   foo.SetThrowExceptionOnMissingEntry(true);
   try {
      nTRV = foo(777);
      // never gets here
      printf("default return value is %d\n", nTRV);
   } catch ( int e ) {
      printf("exception #%02d caught\n", e);
   }

   getch();

	return 0;
}
